;     VC17B   PeakTech 3415.

;----- Register Files User -------------------------------------------------

BUF_RX			EQU	H'0010'		
BUF_TX			EQU	H'0011'
CNT_SMPL_HI		EQU	H'0012'
BT			EQU	H'0014'
SAMPLE			EQU	H'0015'


TAB		EQU	H'0018'	;   
;----- Bitmap ----------------------------------------------------
		
;#define			TAB+0,	0
;#define			TAB+0,	1
;#define			TAB+0,	2
;#define			TAB+0,	3
#define		_P3_		TAB+0,	4
#define		_E1_		TAB+0,	5
#define		_F1_		TAB+0,	6
#define		_A1_		TAB+0,	7	

#define		_BAT_		TAB+1,	0
#define		_DEL_		TAB+1,	1
;#define			TAB+1,	2
#define		_BUZ_		TAB+1,	3
#define		_D1_		TAB+1,	4
#define		_C1_		TAB+1,	5
#define		_G1_		TAB+1,	6
#define		_B1_		TAB+1,	7

#define		_G5_		TAB+2,	0
#define		_E4_		TAB+2,	1
#define		_F4_		TAB+2,	2
#define		_A4_		TAB+2,	3
#define		_HOLD_		TAB+2,	4
#define		_degF_		TAB+2,	5
#define		_degC_		TAB+2,	6
#define		_Diod_		TAB+2,	7

#define		_D4_		TAB+3,	0
#define		_C4_		TAB+3,	1
#define		_G4_		TAB+3,	2
#define		_B4_		TAB+3,	3
#define		_MAX_		TAB+3,	4
#define		_MIN_		TAB+3,	5
#define		_Duty_		TAB+3,	6
#define		_AC_		TAB+3,	7

#define		_P1_		TAB+4,	0
#define		_E3_		TAB+4,	1
#define		_F3_		TAB+4,	2
#define		_A3_		TAB+4,	3
#define		_F_		TAB+4,	4
#define		_uF_		TAB+4,	5
#define		_mF_		TAB+4,	6
#define		_nF_		TAB+4,	7

#define		_D3_		TAB+5,	0
#define		_C3_		TAB+5,	1
#define		_G3_		TAB+5,	2
#define		_B3_		TAB+5,	3
#define		_Hz_		TAB+5,	4
#define		_Ohm_		TAB+5,	5
#define		_k_		TAB+5,	6
#define		_M_		TAB+5,	7

#define		_P2_		TAB+6,	0
#define		_E2_		TAB+6,	1
#define		_F2_		TAB+6,	2
#define		_A2_		TAB+6,	3
#define		_V_		TAB+6,	4
#define		_mV_		TAB+6,	5
#define		_DC_		TAB+6,	6
#define		_A_		TAB+6,	7

#define		_D2_		TAB+7,	0
#define		_C2_		TAB+7,	1
#define		_G2_		TAB+7,	2
#define		_B2_		TAB+7,	3
#define		_AUTO_		TAB+7,	4
#define		_MANU_		TAB+7,	5
#define		_uA_		TAB+7,	6
#define		_mA_		TAB+7,	7

;----- GPIO --------------------------------------------------------------

RX			EQU	H'0001'		;
TX			EQU	H'0002'	
STROB			EQU	H'0000'

;----- const -------------------------------------------------------------

sample_rx		EQU	.80	;    

;-------------------------------------------------------------------------

        LIST
	org	0x00

init
	movwf	OSCCAL
	movlw	b'00001010'	;GP3-, GP2-, GP1-, GP0-
	tris	GPIO	
	movlw	b'10001011'	;  ,  WDT ~1.1 
	option	

main
	bsf	GPIO,	TX

;---------------------------------
;    

ma1
	btfss	GPIO,	RX
	goto	ma1
	btfss	GPIO,	RX
	goto	ma1
	btfss	GPIO,	RX
	goto	ma1

;----------------------------------
;   -

start
	nop
	nop
;start+2
	bsf	GPIO,	TX

;--------------------------------------------
;     (-)

st1
	btfsc	GPIO,	RX
	goto	st1
	btfsc	GPIO,	RX
	goto	st1
	btfsc	GPIO,	RX
	goto	st1

;--------------------------------------------
;  -,
;   ,     
;      2400 

	movlw	sample_rx-1
	call	bit_detect
	movlw	(sample_rx-1)/2
	subwf	CNT_SMPL_HI
	btfsc	STATUS,	C
	goto	main	;     -  

;-------------------------------------------------------------
;  (8 ),
;  ,    
 
	bcf	GPIO,	TX	;-   	
	nop 
	movlw	.8
	movwf	BT

shift
	movlw	sample_rx
	call	bit_detect
	movlw	sample_rx/2
	subwf	CNT_SMPL_HI
	rrf	BUF_RX

	rrf	BUF_TX
	btfsc	STATUS,	C
	bsf	GPIO,	TX
	btfss	STATUS,	C
	bcf	GPIO,	TX

	decfsz	BT
	goto	shift

;---------------------------------------------------------------
; -

bit_stop
	movlw	sample_rx-10
	call	bit_detect
	movlw	(sample_rx-10)/2
	subwf	CNT_SMPL_HI
	btfss	STATUS,C
	goto	main	;      -
	clrwdt

;-------------------------------------------------------------------------
;   (  )
	
data_tab
	movf	BUF_RX,	W
	andlw	b'11110000'
	movwf	BUF_TX

	movlw	TAB
	movwf	FSR
	swapf	BUF_RX,	W
	andlw	b'00000111'
	addwf	FSR

	movlw	b'00001111'
	andwf	BUF_RX
	btfsc	BUF_TX,	7
	swapf	BUF_RX

	btfss	BUF_TX,	7
	movlw	b'11110000'
	andwf	INDF,	W
	iorwf	BUF_RX,	W
	movwf	INDF

convert
	movlw	b'00010000'
	addwf	BUF_TX
	btfsc	STATUS,	C
	addwf	BUF_TX

	swapf	BUF_TX,	W
	andlw	b'00001111'
	addwf	PCL	
	goto	main	
	goto	conv_b01
	goto	conv_b02	
	goto	conv_b03
	goto	conv_b04	
	goto	conv_b05
	goto	conv_b06	
	goto	conv_b07	
	goto	conv_b08	
	goto	conv_b09
	goto	conv_b10	
	goto	conv_b11
	goto	conv_b12
	goto	conv_b13
	goto	conv_b14
	goto	conv_b15


conv_b01
	nop	
	nop
	btfsc	_AUTO_
	bsf	BUF_TX,	2
	btfsc	_DC_
	bsf	BUF_TX,	1
	btfsc	_AC_
	bsf	BUF_TX,	0
	goto	start

conv_b02
	btfsc	_A4_
	bsf	BUF_TX,	3
	btfsc	_F4_
	bsf	BUF_TX,	2
	btfsc	_E4_
	bsf	BUF_TX,	1
	btfsc	_G5_
	bsf	BUF_TX,	0
	goto	start

conv_b03
	btfsc	_B4_
	bsf	BUF_TX,	3
	btfsc	_G4_
	bsf	BUF_TX,	2
	btfsc	_C4_
	bsf	BUF_TX,	1
	btfsc	_D4_
	bsf	BUF_TX,	0
	goto	start

conv_b04
	btfsc	_A3_
	bsf	BUF_TX,	3
	btfsc	_F3_
	bsf	BUF_TX,	2
	btfsc	_E3_
	bsf	BUF_TX,	1
	btfsc	_P1_
	bsf	BUF_TX,	0
	goto	start

conv_b05
	btfsc	_B3_
	bsf	BUF_TX,	3
	btfsc	_G3_
	bsf	BUF_TX,	2
	btfsc	_C3_
	bsf	BUF_TX,	1
	btfsc	_D3_
	bsf	BUF_TX,	0
	goto	start

conv_b06
	btfsc	_A2_
	bsf	BUF_TX,	3
	btfsc	_F2_
	bsf	BUF_TX,	2
	btfsc	_E2_
	bsf	BUF_TX,	1
	btfsc	_P2_
	bsf	BUF_TX,	0
	goto	start

conv_b07
	btfsc	_B2_
	bsf	BUF_TX,	3
	btfsc	_G2_
	bsf	BUF_TX,	2
	btfsc	_C2_
	bsf	BUF_TX,	1
	btfsc	_D2_
	bsf	BUF_TX,	0
	goto	start

conv_b08
	btfsc	_A1_
	bsf	BUF_TX,	3
	btfsc	_F1_
	bsf	BUF_TX,	2
	btfsc	_E1_
	bsf	BUF_TX,	1
	btfsc	_P3_
	bsf	BUF_TX,	0
	goto	start

conv_b09
	btfsc	_B1_
	bsf	BUF_TX,	3
	btfsc	_G1_
	bsf	BUF_TX,	2
	btfsc	_C1_
	bsf	BUF_TX,	1
	btfsc	_D1_
	bsf	BUF_TX,	0
	goto	start

conv_b10
	btfsc	_Diod_
	bsf	BUF_TX,	3
	btfsc	_k_
	bsf	BUF_TX,	2
	btfsc	_nF_
	bsf	BUF_TX,	1
	btfsc	_uA_
	bsf	BUF_TX,	0
	btfsc	_uF_
	bsf	BUF_TX,	0
	goto	start+2

conv_b11
	btfsc	_M_
	bsf	BUF_TX,	2
	btfsc	_Duty_
	bsf	BUF_TX,	1
	btfsc	_mA_
	bsf	BUF_TX,	0
	btfsc	_mV_
	bsf	BUF_TX,	0
	btfsc	_mF_
	bsf	BUF_TX,	0
	goto	start+2

conv_b12
	btfsc	_HOLD_
	bsf	BUF_TX,	3
	btfsc	_DEL_
	bsf	BUF_TX,	2
	btfsc	_Ohm_
	bsf	BUF_TX,	1
	btfsc	_F_
	bsf	BUF_TX,	0
	goto	start

conv_b13
	btfsc	_BAT_
	bsf	BUF_TX,	3
	btfsc	_Hz_
	bsf	BUF_TX,	2
	btfsc	_V_
	bsf	BUF_TX,	1
	btfsc	_A_
	bsf	BUF_TX,	0
	goto	start

conv_b14
	nop
	nop
	nop
	nop
	btfsc	_degC_
	bsf	BUF_TX,	1
	btfsc	_degF_
	bsf	BUF_TX,	0
	goto	start

conv_b15
	btfsc	_MAX_
	bsf	BUF_TX,	3
	nop
	nop
	btfsc	_MIN_
	bsf	BUF_TX,	1
	nop
	nop	
	goto	start

;----------------------------------------------------
;  ,
;     

bit_detect
	movwf	SAMPLE
	clrf	CNT_SMPL_HI
b1
	btfsc	GPIO,	RX
	incf	CNT_SMPL_HI
	decfsz	SAMPLE
	goto	b1
	retlw	.0


END
